diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/antenna/bindings/modulegen__gcc_LP64.py ns-3.31/src/antenna/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/antenna/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/antenna/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -889,22 +956,22 @@
     cls.add_method('Connect', 
                    'bool', 
                    [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::ConnectWithoutContext(ns3::ObjectBase * obj, ns3::CallbackBase const & cb) const [member function]
     cls.add_method('ConnectWithoutContext', 
                    'bool', 
                    [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('ns3::CallbackBase const &', 'cb')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::Disconnect(ns3::ObjectBase * obj, std::string context, ns3::CallbackBase const & cb) const [member function]
     cls.add_method('Disconnect', 
                    'bool', 
                    [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::DisconnectWithoutContext(ns3::ObjectBase * obj, ns3::CallbackBase const & cb) const [member function]
     cls.add_method('DisconnectWithoutContext', 
                    'bool', 
                    [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('ns3::CallbackBase const &', 'cb')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3AntennaModel_methods(root_module, cls):
@@ -916,7 +983,7 @@
     cls.add_method('GetGainDb', 
                    'double', 
                    [param('ns3::Angles', 'a')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## antenna-model.h (module 'antenna'): static ns3::TypeId ns3::AntennaModel::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -933,22 +1000,22 @@
     cls.add_method('Get', 
                    'bool', 
                    [param('ns3::ObjectBase const *', 'object'), param('ns3::AttributeValue &', 'attribute')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeAccessor::HasGetter() const [member function]
     cls.add_method('HasGetter', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeAccessor::HasSetter() const [member function]
     cls.add_method('HasSetter', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeAccessor::Set(ns3::ObjectBase * object, ns3::AttributeValue const & value) const [member function]
     cls.add_method('Set', 
                    'bool', 
                    [param('ns3::ObjectBase *', 'object', transfer_ownership=False), param('ns3::AttributeValue const &', 'value')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3AttributeChecker_methods(root_module, cls):
@@ -960,17 +1027,17 @@
     cls.add_method('Check', 
                    'bool', 
                    [param('ns3::AttributeValue const &', 'value')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeChecker::Copy(ns3::AttributeValue const & source, ns3::AttributeValue & destination) const [member function]
     cls.add_method('Copy', 
                    'bool', 
                    [param('ns3::AttributeValue const &', 'source'), param('ns3::AttributeValue &', 'destination')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeChecker::Create() const [member function]
     cls.add_method('Create', 
                    'ns3::Ptr< ns3::AttributeValue >', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeChecker::CreateValidValue(ns3::AttributeValue const & value) const [member function]
     cls.add_method('CreateValidValue', 
                    'ns3::Ptr< ns3::AttributeValue >', 
@@ -980,17 +1047,17 @@
     cls.add_method('GetUnderlyingTypeInformation', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): std::string ns3::AttributeChecker::GetValueTypeName() const [member function]
     cls.add_method('GetValueTypeName', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeChecker::HasUnderlyingTypeInformation() const [member function]
     cls.add_method('HasUnderlyingTypeInformation', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3AttributeValue_methods(root_module, cls):
@@ -1002,17 +1069,17 @@
     cls.add_method('Copy', 
                    'ns3::Ptr< ns3::AttributeValue >', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): bool ns3::AttributeValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
     cls.add_method('DeserializeFromString', 
                    'bool', 
                    [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## attribute.h (module 'core'): std::string ns3::AttributeValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
     cls.add_method('SerializeToString', 
                    'std::string', 
                    [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackChecker_methods(root_module, cls):
@@ -1031,12 +1098,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## callback.h (module 'core'): bool ns3::CallbackImplBase::IsEqual(ns3::Ptr<const ns3::CallbackImplBase> other) const [member function]
     cls.add_method('IsEqual', 
                    'bool', 
                    [param('ns3::Ptr< ns3::CallbackImplBase const >', 'other')], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::Demangle(std::string const & mangled) [member function]
     cls.add_method('Demangle', 
                    'std::string', 
@@ -1046,7 +1113,7 @@
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['ns3::ObjectBase*'], visibility='protected')
+                   template_parameters=['ns3::ObjectBase*'], is_static=True, visibility='protected')
     return
 
 def register_Ns3CallbackValue_methods(root_module, cls):
@@ -1389,7 +1456,7 @@
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -1401,7 +1468,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -1411,7 +1478,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/antenna/model/three-gpp-antenna-array-model.cc ns-3.31/src/antenna/model/three-gpp-antenna-array-model.cc
--- ns-3.30.1/src/antenna/model/three-gpp-antenna-array-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/antenna/model/three-gpp-antenna-array-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,221 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+*   University of Padova
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*
+*/
+
+#include "three-gpp-antenna-array-model.h"
+#include "ns3/log.h"
+#include "ns3/double.h"
+#include "ns3/uinteger.h"
+#include "ns3/boolean.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ThreeGppAntennaArrayModel");
+
+NS_OBJECT_ENSURE_REGISTERED (ThreeGppAntennaArrayModel);
+
+ThreeGppAntennaArrayModel::ThreeGppAntennaArrayModel (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_isOmniTx = false;
+}
+
+ThreeGppAntennaArrayModel::~ThreeGppAntennaArrayModel (void)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TypeId
+ThreeGppAntennaArrayModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ThreeGppAntennaArrayModel")
+    .SetParent<Object> ()
+    .AddConstructor<ThreeGppAntennaArrayModel> ()
+    .AddAttribute ("AntennaHorizontalSpacing",
+               "Horizontal spacing between antenna elements, in multiples of wave length",
+               DoubleValue (0.5),
+               MakeDoubleAccessor (&ThreeGppAntennaArrayModel::m_disH),
+               MakeDoubleChecker<double> ())
+    .AddAttribute ("AntennaVerticalSpacing",
+               "Vertical spacing between antenna elements, in multiples of wave length",
+               DoubleValue (0.5),
+               MakeDoubleAccessor (&ThreeGppAntennaArrayModel::m_disV),
+               MakeDoubleChecker<double> ())
+    .AddAttribute ("NumColumns",
+               "Horizontal size of the array",
+               UintegerValue (4),
+               MakeUintegerAccessor (&ThreeGppAntennaArrayModel::m_numColumns),
+               MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("NumRows",
+               "Vertical size of the array",
+               UintegerValue (4),
+               MakeUintegerAccessor (&ThreeGppAntennaArrayModel::m_numRows),
+               MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("BearingAngle",
+               "The bearing angle in radians",
+               DoubleValue (0.0),
+               MakeDoubleAccessor (&ThreeGppAntennaArrayModel::m_alpha),
+               MakeDoubleChecker<double> (-M_PI, M_PI))
+    .AddAttribute ("DowntiltAngle",
+               "The downtilt angle in radians",
+               DoubleValue (0.0),
+               MakeDoubleAccessor (&ThreeGppAntennaArrayModel::m_beta),
+               MakeDoubleChecker<double> (0, M_PI))
+    .AddAttribute ("ElementGain",
+               "Directional gain of an antenna element in dBi",
+               DoubleValue (4.97),
+               MakeDoubleAccessor (&ThreeGppAntennaArrayModel::m_gE),
+               MakeDoubleChecker<double> (0, 8))
+    .AddAttribute ("IsotropicElements",
+               "If true, use an isotropic radiation pattern (for testing purposes)",
+               BooleanValue (false),
+               MakeBooleanAccessor (&ThreeGppAntennaArrayModel::m_isIsotropic),
+               MakeBooleanChecker ())
+  ;
+  return tid;
+}
+
+bool
+ThreeGppAntennaArrayModel::IsOmniTx (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_isOmniTx;
+}
+
+void
+ThreeGppAntennaArrayModel::ChangeToOmniTx (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_isOmniTx = true;
+}
+
+void
+ThreeGppAntennaArrayModel::SetBeamformingVector (const ComplexVector &beamformingVector)
+{
+  NS_LOG_FUNCTION (this);
+  m_isOmniTx = false;
+  m_beamformingVector = beamformingVector;
+}
+
+const ThreeGppAntennaArrayModel::ComplexVector &
+ThreeGppAntennaArrayModel::GetBeamformingVector(void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_beamformingVector;
+}
+
+std::pair<double, double>
+ThreeGppAntennaArrayModel::GetElementFieldPattern (Angles a) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // normalize phi (if needed)
+  a.phi = fmod (a.phi + M_PI, 2 * M_PI);
+  if (a.phi < 0)
+      a.phi += M_PI;
+  else 
+      a.phi -= M_PI;
+
+  NS_ASSERT_MSG (a.theta >= 0 && a.theta <= M_PI, "The vertical angle should be between 0 and M_PI");
+  NS_ASSERT_MSG (a.phi >= -M_PI && a.phi <= M_PI, "The horizontal angle should be between -M_PI and M_PI");
+
+  // convert the theta and phi angles from GCS to LCS using eq. 7.1-7 and 7.1-8 in 3GPP TR 38.901
+  // NOTE we assume a fixed slant angle of 0 degrees
+  double thetaPrime = std::acos (cos (m_beta)*cos (a.theta) + sin (m_beta)*cos (a.phi-m_alpha)*sin (a.theta));
+  double phiPrime = std::arg (std::complex<double> (cos (m_beta)*sin (a.theta)*cos (a.phi-m_alpha) - sin (m_beta)*cos (a.theta), sin (a.phi-m_alpha)*sin (a.theta)));
+  NS_LOG_DEBUG (a.theta << " " << thetaPrime << " " << a.phi << " " << phiPrime);
+
+  double aPrimeDb = GetRadiationPattern (thetaPrime, phiPrime);
+  double aPrime = pow (10, aPrimeDb / 10); // convert to linear
+
+  // compute psi using eq. 7.1-15 in 3GPP TR 38.901, assuming that the slant 
+  // angle (gamma) is 0
+  double psi = std::arg (std::complex<double> (cos (m_beta) * sin (a.theta) - sin (m_beta) * cos (a.theta)* cos (a.phi - m_alpha), sin (m_beta)* sin (a.phi-m_alpha)));
+  NS_LOG_DEBUG ("psi " << psi);
+
+  // compute the antenna element field pattern in the vertical polarization using
+  // eq. 7.3-4 in 3GPP TR 38.901
+  // NOTE we assume vertical polarization, hence the field pattern in the
+  // horizontal polarization is 0
+  double fieldThetaPrime = std::sqrt (aPrime);
+
+  // convert the antenna element field pattern to GCS using eq. 7.1-11
+  // in 3GPP TR 38.901
+  double fieldTheta = cos (psi) * fieldThetaPrime;
+  double fieldPhi = sin (psi) * fieldThetaPrime;
+  NS_LOG_DEBUG (a.phi/M_PI*180 << " " << a.theta/M_PI*180 << " " << fieldTheta*fieldTheta + fieldPhi*fieldPhi);
+
+  return std::make_pair (fieldPhi, fieldTheta);
+}
+
+double
+ThreeGppAntennaArrayModel::GetRadiationPattern (double thetaRadian, double phiRadian) const
+{
+  if (m_isIsotropic)
+  {
+    return 0;
+  }
+
+  // convert the angles in degrees
+  double thetaDeg = thetaRadian * 180 / M_PI;
+  double phiDeg = phiRadian * 180 / M_PI;
+  NS_ASSERT_MSG (thetaDeg >= 0 && thetaDeg <= 180, "the vertical angle should be the range of [0,180]");
+  NS_ASSERT_MSG (phiDeg >= -180 && phiDeg <= 180, "the horizontal angle should be the range of [-180,180]");
+
+  // compute the radiation power pattern using equations in table 7.3-1 in
+  // 3GPP TR 38.901
+  double A_M = 30; // front-back ratio expressed in dB
+  double SLA = 30; // side-lobe level limit expressed in dB
+
+  double A_v = -1 * std::min (SLA,12 * pow ((thetaDeg - 90) / 65,2)); // vertical cut of the radiation power pattern (dB)
+  double A_h = -1 * std::min (A_M,12 * pow (phiDeg / 65,2)); // horizontal cut of the radiation power pattern (dB)
+
+  double A = m_gE - 1 * std::min (A_M,- A_v - A_h); // 3D radiation power pattern (dB)
+
+  return A; // 3D radiation power pattern in dB
+}
+
+Vector
+ThreeGppAntennaArrayModel::GetElementLocation (uint64_t index) const
+{
+  NS_LOG_FUNCTION (this);
+
+  // compute the element coordinates in the LCS
+  // assume the left bottom corner is (0,0,0), and the rectangular antenna array is on the y-z plane.
+  double xPrime = 0;
+  double yPrime = m_disH * (index % m_numColumns);
+  double zPrime = m_disV * floor (index / m_numColumns);
+
+  // convert the coordinates to the GCS using the rotation matrix 7.1-4 in 3GPP
+  // TR 38.901
+  Vector loc;
+  loc.x = cos(m_alpha)*cos (m_beta)*xPrime - sin (m_alpha)*yPrime + cos (m_alpha)*sin (m_beta)*zPrime;
+  loc.y = sin (m_alpha)*cos(m_beta)*xPrime + cos (m_alpha)*yPrime + sin (m_alpha)*sin (m_beta)*zPrime;
+  loc.z = -sin (m_beta)*xPrime+cos(m_beta)*zPrime;
+  return loc;
+}
+
+uint64_t
+ThreeGppAntennaArrayModel::GetNumberOfElements (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_numRows * m_numColumns;
+}
+
+} /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/antenna/model/three-gpp-antenna-array-model.h ns-3.31/src/antenna/model/three-gpp-antenna-array-model.h
--- ns-3.30.1/src/antenna/model/three-gpp-antenna-array-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/antenna/model/three-gpp-antenna-array-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,135 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+*   University of Padova
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*
+*/
+
+#ifndef THREE_GPP_ANTENNA_ARRAY_MODEL_H_
+#define THREE_GPP_ANTENNA_ARRAY_MODEL_H_
+
+#include <ns3/antenna-model.h>
+#include <complex>
+
+namespace ns3 {
+
+/**
+ * \ingroup antenna
+ *
+ * \brief Class implementing the antenna model defined in 3GPP TR 38.901 V15.0.0
+ * 
+ * \note the current implementation supports the modeling of antenna arrays 
+ * composed of a single panel and with single (vertical) polarization.
+ */
+class ThreeGppAntennaArrayModel : public Object
+{
+public:
+
+  /**
+   * Constructor
+   */
+  ThreeGppAntennaArrayModel (void);
+
+  /**
+   * Destructor
+   */
+  virtual ~ThreeGppAntennaArrayModel (void);
+
+  // inherited from Object
+  static TypeId GetTypeId (void);
+
+  typedef std::vector<std::complex<double> > ComplexVector; //!< type definition for complex vectors
+
+  /**
+   * Returns the horizontal and vertical components of the antenna element field
+   * pattern at the specified direction. Only vertical polarization is considered.
+   * \param a the angle indicating the interested direction
+   * \return a pair in which the first element is the horizontal component
+   *         of the field pattern and the second element is the vertical
+   *         component of the field pattern
+   */
+  std::pair<double, double> GetElementFieldPattern (Angles a) const;
+
+  /**
+   * Returns the location of the antenna element with the specified
+   * index assuming the left bottom corner is (0,0,0), normalized
+   * with respect to the wavelength.
+   * Antenna elements are scanned row by row, left to right and bottom to top.
+   * For example, an antenna with 2 rows and 3 columns will be ordered as follows:
+   * ^ z
+   * |  3 4 5
+   * |  0 1 2
+   * ----------> y
+   *
+   * \param index index of the antenna element
+   * \return the 3D vector that represents the position of the element
+   */
+  virtual Vector GetElementLocation (uint64_t index) const;
+
+  /**
+   * Returns the number of antenna elements
+   * \return the number of antenna elements
+   */
+  virtual uint64_t GetNumberOfElements (void) const;
+
+  /**
+   * Returns true if the antenna is configured for omnidirectional transmissions
+   * \return whether the transmission is set to omni
+   */
+  bool IsOmniTx (void) const;
+
+  /**
+   * Change the antenna model to omnidirectional (ignoring the beams)
+   */
+  void ChangeToOmniTx (void);
+
+  /**
+   * Sets the beamforming vector to be used
+   * \param beamformingVector the beamforming vector
+   */
+  void SetBeamformingVector (const ComplexVector &beamformingVector);
+
+  /**
+   * Returns the beamforming vector that is currently being used
+   * \return the current beamforming vector
+   */
+  const ComplexVector & GetBeamformingVector (void) const;
+
+private:
+  /**
+   * Returns the radiation power pattern of a single antenna element in dB,
+   * generated according to Table 7.3-1 in 3GPP TR 38.901
+   * \param vAngleRadian the vertical angle in radians
+   * \param hAngleRadian the horizontal angle in radians
+   * \return the radiation power pattern in dB
+   */
+  double GetRadiationPattern (double vAngleRadian, double hAngleRadian) const;
+
+  bool m_isOmniTx; //!< true if the antenna is configured for omni transmissions
+  ComplexVector m_beamformingVector; //!< the beamforming vector in use
+  uint32_t m_numColumns; //!< number of columns
+  uint32_t m_numRows; //!< number of rows
+  double m_disV; //!< antenna spacing in the vertical direction in multiples of wave length
+  double m_disH; //!< antenna spacing in the horizontal direction in multiples of wave length
+  double m_alpha; //!< the bearing angle in radians
+  double m_beta; //!< the downtilt angle in radians
+  double m_gE; //!< directional gain of a single antenna element (dBi)
+  bool m_isIsotropic; //!< if true, antenna elements are isotropic
+};
+
+} /* namespace ns3 */
+
+#endif /* SRC_THREE_GPP_ANTENNA_ARRAY_MODEL_H_ */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/antenna/wscript ns-3.31/src/antenna/wscript
--- ns-3.30.1/src/antenna/wscript	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/src/antenna/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -10,8 +10,9 @@
         'model/isotropic-antenna-model.cc',
         'model/cosine-antenna-model.cc',
         'model/parabolic-antenna-model.cc',
+        'model/three-gpp-antenna-array-model.cc',
         ]
- 
+
     module_test = bld.create_ns3_module_test_library('antenna')
     module_test.source = [
         'test/test-angles.cc',
@@ -20,6 +21,12 @@
         'test/test-cosine-antenna.cc',
         'test/test-parabolic-antenna.cc',
         ]
+
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #   'test/antenna-examples-test-suite.cc',
+            ])
     
     headers = bld(features='ns3header')
     headers.module = 'antenna'
@@ -29,6 +36,7 @@
         'model/isotropic-antenna-model.h',
         'model/cosine-antenna-model.h',
         'model/parabolic-antenna-model.h',
+        'model/three-gpp-antenna-array-model.h',
         ]
 
     bld.ns3_python_bindings()
